<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------
import type { Metadata } from "@/stores/useSubmissionStore";
import { vuetifyRenderers } from "@jsonforms/vue-vuetify";
import { markRaw } from "vue";
import { useSubmissionStore } from "@/stores/useSubmissionStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import {
  and,
  formatIs,
  isAnyOfControl,
  isObjectArrayControl,
  isObjectArrayWithNesting,
  isOneOfControl,
  isOneOfEnumControl,
  isPrimitiveArrayControl,
  isStringControl,
  or,
} from "@jsonforms/core";
import { type JsonFormsRendererRegistryEntry, rankWith, type Tester } from "@jsonforms/core";
import AnyOfControlRenderer from "@/components/JsonFormRenderers/AnyOfRenderer.vue";
import ArrayControlRenderer from "@/components/JsonFormRenderers/ArrayControlRenderer.vue";
import ArrayLayoutRenderer from "@/components/JsonFormRenderers/ArrayLayoutRenderer.vue";
import DOIControlRenderer from "@/components/JsonFormRenderers/DOIControlRenderer.vue";
import MultiStringControlRenderer from "@/components/JsonFormRenderers/MultiStringControlRenderer.vue";
import NcbiPubmedIDControlRenderer from "@/components/JsonFormRenderers/NcbiPubmedIDControlRenderer.vue";
import NcbiPubmedTitleControlRenderer from "@/components/JsonFormRenderers/NcbiPubmedTitleControlRenderer.vue";
import NcbiTaxonIDControlRenderer from "@/components/JsonFormRenderers/NcbiTaxonIDControlRenderer.vue";
import NcbiTaxonSNControlRenderer from "@/components/JsonFormRenderers/NcbiTaxonSNControlRenderer.vue";
import OneOfEnumControlRenderer from "@/components/JsonFormRenderers/OneOfEnumControlRenderer.vue";
import OneOfControlRenderer from "@/components/JsonFormRenderers/OneOfRenderer.vue";
import RORControlRenderer from "@/components/JsonFormRenderers/RORControlRenderer.vue";
import RORNameControlRenderer from "@/components/JsonFormRenderers/RORNameControlRenderer.vue";
import OrcidControlRenderer from "@/components/JsonFormRenderers/OrcidControlRenderer.vue";
import { JsonForms } from "@jsonforms/vue";

// ----------------------------------------------------------------
// Props
// ----------------------------------------------------------------
const props = defineProps({
  metadataObjectType: {
    type: String,
    required: true,
    description: "Name of the type of metadata object",
  },
  metadataObjectID: {
    type: String,
    required: true,
    description: "ID of the metadata object",
  },
});

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------
const submissionStore = useSubmissionStore();
const workspaceStore = useWorkspaceStore();

const router = useRouter();

const loading = ref(true);
const search = ref("");
const changedMetadata = ref({});

const confirmDialog = ref(false);
const pendingItem = ref<any>(null);
const pendingValue = ref<any>(null);

// Define table headers
const headers = [
  { title: "Field", value: "field", width: "20%", sortable: true },
  { title: "Value", value: "value", width: "80%" },
];

const metadataItems = ref<Metadata[]>([]);

// ----------------------------------------------------------------
// JSONForms Setup
// ----------------------------------------------------------------

// Initialize AJV
let ajv = newAjv();

function buildRendererRegistryEntry(testRenderer: any, controlType: Tester) {
  const entry: JsonFormsRendererRegistryEntry = {
    renderer: testRenderer,
    tester: rankWith(3, controlType),
  };
  return entry;
}

const OneOfRendererEntry = buildRendererRegistryEntry(OneOfControlRenderer, isOneOfControl);
const AnyOfRendererEntry = buildRendererRegistryEntry(AnyOfControlRenderer, isAnyOfControl);
const ArrayControlEntry = buildRendererRegistryEntry(
  ArrayControlRenderer,
  or(isObjectArrayControl, isPrimitiveArrayControl),
);
const ArrayLayoutEntry = buildRendererRegistryEntry(ArrayLayoutRenderer, isObjectArrayWithNesting);
const NcbiTaxonSNControlEntry = buildRendererRegistryEntry(
  NcbiTaxonSNControlRenderer,
  and(isStringControl, formatIs("ncbi-taxon-sn")),
);
const NcbiTaxonIdControlEntry = buildRendererRegistryEntry(
  NcbiTaxonIDControlRenderer,
  and(isStringControl, formatIs("ncbi-taxon-id")),
);
const NcbiPubmedIDControlEntry = buildRendererRegistryEntry(
  NcbiPubmedIDControlRenderer,
  and(isStringControl, formatIs("ncbi-pubmed-id")),
);
const NcbiPubmedTitleControlEntry = buildRendererRegistryEntry(
  NcbiPubmedTitleControlRenderer,
  and(isStringControl, formatIs("ncbi-pubmed-title")),
);
const OneOfEnumControlEntry = buildRendererRegistryEntry(
  OneOfEnumControlRenderer,
  isOneOfEnumControl,
);
const MultiStringControlEntry = buildRendererRegistryEntry(
  MultiStringControlRenderer,
  and(isStringControl, formatIs("multi")),
);
const OrcidControlEntry = buildRendererRegistryEntry(
  OrcidControlRenderer,
  and(isStringControl, formatIs("orcid")),
);
const DOIControlEntry = buildRendererRegistryEntry(
  DOIControlRenderer,
  and(isStringControl, formatIs("doi")),
);
const RORControlEntry = buildRendererRegistryEntry(
  RORControlRenderer,
  and(isStringControl, formatIs("ror")),
);
const RORNameControlEntry = buildRendererRegistryEntry(
  RORNameControlRenderer,
  and(isStringControl, formatIs("organization-name")),
);

const customEntryNames = [
  "one-of-select-renderer",
  "array-control-renderer",
  "array-layout-renderer",
  "ncbi-taxon-sn-control-renderer",
  "ncbi-taxon-id-control-renderer",
  "ncbi-pubmed-id-control-renderer",
  "ncbi-pubmed-title-control-renderer",
  "any-of-select-renderer",
  "oneof-enum-control-renderer",
  "MultiStringControlRenderer",
  "orcid-control-renderer",
  "doi-control-renderer",
  "ror-control-renderer",
  "ror-name-control-renderer",
];

const renderers = [
  markRaw(OneOfEnumControlEntry),
  markRaw(OneOfRendererEntry),
  markRaw(ArrayControlEntry),
  markRaw(ArrayLayoutEntry),
  markRaw(NcbiTaxonSNControlEntry),
  markRaw(NcbiTaxonIdControlEntry),
  markRaw(NcbiPubmedIDControlEntry),
  markRaw(NcbiPubmedTitleControlEntry),
  markRaw(AnyOfRendererEntry),
  markRaw(MultiStringControlEntry),
  markRaw(OrcidControlEntry),
  markRaw(DOIControlEntry),
  markRaw(RORControlEntry),
  markRaw(RORNameControlEntry),
];

for (const key in vuetifyRenderers) {
  if (!customEntryNames.includes(vuetifyRenderers[key].renderer.name)) {
    renderers.push(markRaw(vuetifyRenderers[key]));
  }
}

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------

onMounted(async () => {
  await getMetadata();
  setInterval(async () => {
    await saveMetadata();
  }, 30000);
});

onBeforeUnmount(() => {
  saveMetadata();
});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

/**
 * Fetches and enriches metadata for the current metadata object.
 *
 * This function:
 * 1. Fetches metadata for the specified metadata object ID
 * 2. Retrieves the metadata from the store
 * 3. For each metadata item, fetches its associated schema if available
 * 4. Enriches the metadata items with their schema details
 * 5. Updates the metadataItems ref with the enriched data
 */
async function getMetadata() {
  loading.value = true;
  ajv = newAjv();
  try {
    // fetch the metadata
    await submissionStore.fetchMetadataForObject(props.metadataObjectID).then(async () => {
      const metadata = submissionStore.getMetadata(
        props.metadataObjectType,
        props.metadataObjectID,
      );

      if (metadata && metadata instanceof Map) {
        const metadataArray = Array.from(metadata.values());

        const enrichedMetadata = await Promise.all(
          metadataArray.map(async (item) => {
            // Fetch schema for the field
            if (item.field?.schema) {
              try {
                const response = await fetch(item.field.schema, {
                  headers: { "X-Workspace": workspaceStore.currentWid },
                });

                if (response.ok) {
                  const schemaDetails = await response.json();
                  item.field.schemaDetails = schemaDetails;
                }
              } catch (error) {
                console.error("Error fetching schema:", error);
              }
            }
            return item;
          }),
        );

        metadataItems.value = enrichedMetadata;
      }
    });
  } catch (error) {
    console.error("Error fetching metadata:", error);
  } finally {
    loading.value = false;
  }
}

/**
 * Updates the value and source of a metadata field when changed via form or candidate selection.
 * Only updates if the component is not loading and the new value differs from the current value.
 * Tracks changes in changedMetadata for later saving.
 *
 * @param submissionMetadata - The metadata object being updated
 * @param newValue - The new value to set for the metadata field
 * @param newSource - Optional source information for the new value
 */
function valueChange(submissionMetadata: any, newValue: any, newSource?: any) {
  if (!loading.value && submissionMetadata.value.value !== newValue) {
    ajv = newAjv();
    submissionMetadata.value = {
      value: newValue || "",
      source: newSource,
    };
    changedMetadata.value[submissionMetadata.id] = submissionMetadata.value;
  }
}

/**
 * Saves all pending metadata changes to the server.
 *
 * Iterates through all changed metadata fields stored in changedMetadata and calls
 * updateFieldValue() for each one to persist the changes. After saving, clears the
 * changedMetadata tracking object.
 */
async function saveMetadata() {
  for (const [metadataId, valueData] of Object.entries(changedMetadata.value)) {
    updateFieldValue(props.metadataObjectID, metadataId, valueData);
  }
  changedMetadata.value = {};
}

/**
 * Updates a specific metadata field value on the server and updates metadata object completeness if needed.
 *
 * @param metadataObjectId - The ID of the metadata object to update
 * @param metadataId - The ID of the metadata field to update
 * @param valueData - The new value and source to set for the metadata field
 */
async function updateFieldValue(metadataObjectId: string, metadataId: string, valueData: any) {
  try {
    // Get current validity status before update
    const currentMetadata = submissionStore.getMetadata(
      props.metadataObjectType,
      metadataObjectId,
      metadataId,
    );
    const previousIsValid = currentMetadata?.isValid;

    // Make API request
    const { data } = await useAPIFetch(
      `/api/submissions/${submissionStore.currentSubid}/metadata_objects/${metadataObjectId}/metadata/${metadataId}`,
      {
        method: "PUT",
        body: JSON.stringify(valueData),
        headers: { "X-Workspace": workspaceStore.currentWid },
      },
    );

    // If the validity status changed, update completeness
    if (data.value?.is_valid !== undefined && data.value.is_valid !== previousIsValid) {
      const metadataObjectCompleteness = submissionStore.metadataObjectsMap.get(metadataObjectId)?.completeness[data.value.field.level];
      if (metadataObjectCompleteness) {
        metadataObjectCompleteness.complete = data.value.is_valid ? Math.min(metadataObjectCompleteness.complete + 1, metadataObjectCompleteness.total) : Math.max(metadataObjectCompleteness.complete - 1, 0);
      }
    }
  } catch (error) {
    console.error("Error updating metadata:", error);
  }
}

/**
 * Refreshes the metadata table by saving pending changes and refetching metadata.
 */
async function refreshTable() {
  loading.value = true;
  await saveMetadata().then(async () => {
    await getMetadata();
    loading.value = false;
  });
}

/**
 * Filters the metadata items based on the search query.
 *
 * @param value - The value to filter
 * @param search - The search query
 * @param item - The item to filter
 */
function filter(value: any, search: string, item: any) {
  if (!search || !item) return true;
  try {
    const temp = JSON.parse(JSON.stringify(item)).raw;

    const fieldMatch = temp.field?.name?.toString().toLowerCase().includes(search.toLowerCase());
    // const valueMatch = temp.value?.value?.toString()?.toLowerCase().includes(search.toLowerCase());
    return fieldMatch || false; // || valueMatch
  } catch (error) {
    console.error("Error in filter:", error);
    return false;
  }
}

// Candidate values

/**
 * Checks if a candidate value is already selected for a metadata item.
 *
 * @param item - The metadata item
 * @param candidate - The candidate value to check
 * @returns true if the candidate value is already selected, false otherwise
 */
function isCandidateSelected(item: any, candidate: any): boolean {
  if (item.value?.value === undefined || item.value?.value === null
    || candidate.value === undefined || candidate.value === null) {
    return false;
  }

  if (Array.isArray(candidate.value)) {
    // For arrays, check if all candidate values are included in the current value
    return candidate.value.every((candidateVal: any) =>
      item.value.value.some((currentVal: any) =>
        JSON.stringify(currentVal) === JSON.stringify(candidateVal),
      ),
    );
  }

  // For non-arrays, directly compare the values
  return JSON.stringify(item.value.value) === JSON.stringify(candidate.value);
}

/**
 * Handles the selection of a candidate value for a metadata item.
 *
 * If the value is an array, the candidate value will be added to the current value.
 * If the value is not an array, the candidate value will be set as the current value.
 *
 * @param item - The metadata item
 * @param candidateValue - The candidate value to select
 */
function selectCandidateValue(item: any, candidateValue: any) {
  if (Array.isArray(candidateValue.value)) {
    if (!Array.isArray(item.value.value) || item.value.value.length === 0) {
      valueChange(item, candidateValue.value);
      return;
    }

    // If the candidate is not already fully selected
    if (!isCandidateSelected(item, candidateValue)) {
      const newValue = [...item.value.value];
      candidateValue.value.forEach((newVal: any) => {
        const isDuplicate = newValue.some(existingVal =>
          JSON.stringify(existingVal) === JSON.stringify(newVal),
        );
        if (!isDuplicate) {
          newValue.push(newVal);
        }
      });
      valueChange(item, newValue);
    }
    return;
  }

  // For non-array values, if the current value is not undefined, null, empty string,
  // and the candidate is not already selected, show the confirmation dialog
  if (
    item.value.value !== undefined
    && item.value.value !== null
    && item.value.value !== ""
    && !isCandidateSelected(item, candidateValue)
  ) {
    // Store pending changes and show confirmation dialog
    pendingItem.value = item;
    pendingValue.value = candidateValue;
    confirmDialog.value = true;
  } else if (!isCandidateSelected(item, candidateValue)) {
    // Apply changes directly if no existing value or if values are different
    valueChange(item, candidateValue.value, candidateValue.source);
  }
}

/**
 * Handles the confirmation of a value change.
 *
 * @param confirmed - Whether the confirmation was confirmed
 */
function handleConfirmation(confirmed: boolean) {
  if (confirmed && pendingItem.value && pendingValue.value) {
    valueChange(pendingItem.value, pendingValue.value.value, pendingValue.value.source);
  }

  // Reset pending values
  pendingItem.value = null;
  pendingValue.value = null;
  confirmDialog.value = false;
}

/**
 * Formats a candidate value for display.
 *
 * @param value - The value to format
 * @returns The formatted value
 */
function formatCandidateValue(value: any): string {
  if (value === null || value === undefined) {
    return "";
  }

  if (typeof value === "object" || Array.isArray(value)) {
    try {
      return JSON.stringify(value);
    } catch (e) {
      console.error("Error stringifying value:", e);
      return String(value);
    }
  }

  return String(value);
}

/**
 * Navigates to the source of a metadata item value.
 *
 * @param source - The source of the metadata item value
 */
async function goToSource(source: any) {
  let routeData;
  if (source.object === "Node") {
    routeData = router.resolve({
      path: `/${workspaceStore.currentWSlug}/${source.id}`,
      query: { tab: "metadata" },
    });
    window.open(routeData.href, "_blank");
  } else if (source.object === "Sample") {
    routeData = router.resolve({
      path: `/${workspaceStore.currentWSlug}/${source.node.id}`,
      query: { tab: "sample" },
    });
    window.open(routeData.href, "_blank");
  } else if (source.object === "Data") {
    routeData = router.resolve({
      path: `/${workspaceStore.currentWSlug}/${source.datalink.node.id}`,
      query: { tab: "data" },
    });
    window.open(routeData.href, "_blank");
  }
}

// expandable rows

const expanded = ref<string[]>([]);

function toggleExpand(item: any) {
  const index = expanded.value.indexOf(item.id);
  if (index > -1) {
    expanded.value.splice(index, 1);
  } else {
    expanded.value.push(item.id);
  }
}
</script>

<template>
  <v-container fluid class="pa-0">
    <div class="d-flex justify-end mb-4 pr-6 ga-2">
      <v-tooltip location="bottom" text="Refresh metadata table">
        <template v-slot:activator="{ props: tooltipProps }">
          <v-btn
            v-bind="tooltipProps"
            icon
            size="small"
            @click="refreshTable"
          >
            <v-icon>
              mdi-refresh
            </v-icon>
          </v-btn>
        </template>
      </v-tooltip>

      <v-text-field
        v-model="search"
        label="Search"
        prepend-inner-icon="mdi-magnify"
        hide-details
        single-line
        density="compact"
        style="max-width: 260px"
      />
    </div>
    <v-data-table
      v-model:expanded="expanded"
      :headers="headers"
      :items="metadataItems"
      item-key="id"
      class="elevation-1"
      :loading="loading"
      :search="search"
      :custom-filter="filter"
    >
      <template v-slot:[`item.field`]="{ item }">
        <b>{{ item.field.name }}</b>
        <span
          v-if="item.field.schemaDetails?.level === 'mandatory'"
          class="text-red"
        >*</span>
        <v-icon
          small
          style="margin-left: 8px"
          @click="toggleExpand(item)"
        >
          mdi-information-variant-circle-outline
        </v-icon>
      </template>

      <template v-slot:[`item.value`]="{ item }">
        <JsonForms
          :key="item.id"
          :data="item.value.value"
          :schema="item.field.schemaDetails"
          :renderers="renderers"
          :ajv="ajv"
          @change="(event) => valueChange(item, event.data)"
        />
        <div v-if="item.candidateValues?.length" class="d-flex flex-wrap ga-2 mb-2">
          <div class="d-flex align-center">
            Candidate values
            <v-tooltip location="bottom">
              <template v-slot:activator="{ props: tooltipProps }">
                <v-icon
                  v-bind="tooltipProps"
                  size="small"
                  class="ml-1"
                >
                  mdi-information-variant-circle-outline
                </v-icon>
              </template>
              Candidate values are automatically generated by Madbot. Click on one to use this value
            </v-tooltip>
            &nbsp;:
          </div>
          <v-chip
            v-for="(candidate, index) in item.candidateValues"
            :key="index"
            @click="selectCandidateValue(item, candidate)"
          >
            <template #prepend>
              <v-tooltip location="bottom" text="This candidate value is selected">
                <template v-slot:activator="{ props: tooltipProps }">
                  <v-icon
                    v-if="isCandidateSelected(item, candidate)"
                    v-bind="tooltipProps"
                    color="success"
                    size="medium"
                    class="mr-2"
                  >
                    mdi-check-circle
                  </v-icon>
                </template>
              </v-tooltip>
            </template>
            <template v-if="formatCandidateValue(candidate.value).length > 50">
              <v-tooltip location="bottom">
                <template v-slot:activator="{ props: tooltipProps }">
                  <span v-bind="tooltipProps">
                    {{ truncateTitle(formatCandidateValue(candidate.value), 50) }}
                  </span>
                </template>
                {{ formatCandidateValue(candidate.value) }}
              </v-tooltip>
            </template>
            <template v-else>
              {{ formatCandidateValue(candidate.value) }}
            </template>

            <!-- Source button -->
            <span v-if="candidate.source && ['Node', 'Sample', 'Data'].includes(candidate.source.object)">
              <v-tooltip location="bottom">
                <template v-slot:activator="{ props: tooltipProps }">
                  <v-btn
                    v-bind="tooltipProps"
                    icon="mdi-open-in-new"
                    size="x-small"
                    variant="text"
                    @click.stop="goToSource(candidate.source)"
                  />
                </template>
                Source: {{ candidate.source.object }} <i>{{ truncateTitle(candidate.source.name) }}</i>
              </v-tooltip>
            </span>
            <span v-else-if="candidate.source && candidate.source.object === 'DataAssociation'">
              <v-menu
                open-on-hover
                :open-delay="0"
                location="bottom"
              >
                <template v-slot:activator="{ props: hoverProps }">
                  <v-btn
                    v-bind="hoverProps"
                    icon="mdi-open-in-new"
                    size="x-small"
                    variant="text"
                    @click.stop
                  />
                </template>

                <v-list bg-color="#232F34" class="tooltip-style">
                  <v-list-subheader class="text-white text-body-2">Source: Data Association</v-list-subheader>
                  <v-list-item
                    v-for="(data, i) in candidate.source.data"
                    :key="i"
                  >
                    <v-list-item-title class="text-white text-body-2">
                      {{ truncateTitle(data.name) }}
                      <v-btn
                        icon="mdi-open-in-new"
                        size="x-small"
                        variant="text"
                        @click.stop="goToSource(data)"
                      />
                    </v-list-item-title>
                  </v-list-item>
                </v-list>
              </v-menu>
            </span>
          </v-chip>
        </div>
      </template>

      <!-- Add expanded row template -->
      <template v-slot:expanded-row="{ columns, item }">
        <tr class="v-data-table__expanded__content">
          <td :colspan="columns.length">
            <div class="my-4">
              <v-row>
                <v-col cols="3">
                  <h3>Metadata: {{ item.field.name }}</h3>
                  <p>{{ item.field.schemaDetails?.description }}</p>
                </v-col>
                <v-col cols="2">
                  <p>level: {{ item.field.schemaDetails?.level }}</p>
                  <p>type: {{ item.field.schemaDetails?.type }}</p>
                </v-col>
                <v-col v-if="item.field.schemaDetails?.example" cols="4">
                  <p>Example: {{ item.field.schemaDetails?.example }}</p>
                </v-col>
                <v-col v-if="item.value?.source" cols="4">
                  <div class="d-flex align-center">
                    <p><b>Madbot source metadata</b></p>
                    <v-chip class="ml-2">
                      {{ item.value.source }}
                    </v-chip>
                  </div>
                </v-col>
              </v-row>
            </div>
          </td>
        </tr>
      </template>
    </v-data-table>

    <!-- Add this dialog to your template -->
    <v-dialog v-model="confirmDialog" max-width="400px">
      <v-card>
        <v-card-title>Confirm Value Change</v-card-title>
        <v-card-text>
          Are you sure you want to replace the current value with the selected candidate value?
        </v-card-text>
        <v-card-actions>
          <v-spacer />
          <v-btn @click="handleConfirmation(false)">
            Cancel
          </v-btn>
          <v-btn color="primary" @click="handleConfirmation(true)">
            Confirm
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<style scoped>
.v-data-table {
  width: 100%;
}

:deep(.tooltip-style) {
  border-radius: 8px;
  min-height: 0;
}

:deep(.tooltip-style .v-list-item) {
  min-height: 0;
}
</style>
